diff --git a/drivers/video/Kconfig b/drivers/video/Kconfig
index eed9b357e83..160f4a008bf 100644
--- a/drivers/video/Kconfig
+++ b/drivers/video/Kconfig
@@ -14,9 +14,10 @@ config DM_VIDEO
 	  option compiles in the video uclass and routes all LCD/video access
 	  through this.
 
+if DM_VIDEO
+
 config VIDEO_LOGO
 	bool "Show the U-Boot logo on the display"
-	depends on DM_VIDEO
 	default y if !SPLASH_SCREEN
 	select VIDEO_BMP_RLE8
 	help
@@ -27,7 +28,6 @@ config VIDEO_LOGO
 
 config BACKLIGHT
 	bool "Enable panel backlight uclass support"
-	depends on DM_VIDEO
 	default y
 	help
 	  This provides backlight uclass driver that enables basic panel
@@ -35,7 +35,6 @@ config BACKLIGHT
 
 config VIDEO_PCI_DEFAULT_FB_SIZE
 	hex "Default framebuffer size to use if no drivers request it"
-	depends on DM_VIDEO
 	default 0x1000000 if X86 && PCI
 	default 0 if !(X86 && PCI)
 	help
@@ -54,7 +53,6 @@ config VIDEO_PCI_DEFAULT_FB_SIZE
 
 config VIDEO_COPY
 	bool "Enable copying the frame buffer to a hardware copy"
-	depends on DM_VIDEO
 	help
 	  On some machines (e.g. x86), reading from the frame buffer is very
 	  slow because it is uncached. To improve performance, this feature
@@ -87,7 +85,6 @@ config BACKLIGHT_GPIO
 
 config CMD_VIDCONSOLE
 	bool "Enable vidconsole commands lcdputs and setcurs"
-	depends on DM_VIDEO
 	default y
 	help
 	  Enabling this will provide 'setcurs' and 'lcdputs' commands which
@@ -95,7 +92,6 @@ config CMD_VIDCONSOLE
 
 config VIDEO_BPP8
 	bool "Support 8-bit-per-pixel displays"
-	depends on DM_VIDEO
 	default y
 	help
 	  Support drawing text and bitmaps onto a 8-bit-per-pixel display.
@@ -105,7 +101,6 @@ config VIDEO_BPP8
 
 config VIDEO_BPP16
 	bool "Support 16-bit-per-pixel displays"
-	depends on DM_VIDEO
 	default y
 	help
 	  Support drawing text and bitmaps onto a 16-bit-per-pixel display.
@@ -115,7 +110,6 @@ config VIDEO_BPP16
 
 config VIDEO_BPP32
 	bool "Support 32-bit-per-pixel displays"
-	depends on DM_VIDEO
 	default y
 	help
 	  Support drawing text and bitmaps onto a 32-bit-per-pixel display.
@@ -125,7 +119,6 @@ config VIDEO_BPP32
 
 config VIDEO_ANSI
 	bool "Support ANSI escape sequences in video console"
-	depends on DM_VIDEO
 	default y
 	help
 	  Enable ANSI escape sequence decoding for a more fully functional
@@ -133,7 +126,6 @@ config VIDEO_ANSI
 
 config VIDEO_MIPI_DSI
 	bool "Support MIPI DSI interface"
-	depends on DM_VIDEO
 	help
 	  Support MIPI DSI interface for driving a MIPI compatible device.
 	  The MIPI Display Serial Interface (MIPI DSI) defines a high-speed
@@ -141,8 +133,7 @@ config VIDEO_MIPI_DSI
 
 config CONSOLE_NORMAL
 	bool "Support a simple text console"
-	depends on DM_VIDEO
-	default y if DM_VIDEO
+	default y
 	help
 	  Support drawing text on the frame buffer console so that it can be
 	  used as a console. Rotation is not supported by this driver (see
@@ -151,7 +142,6 @@ config CONSOLE_NORMAL
 
 config CONSOLE_ROTATION
 	bool "Support rotated displays"
-	depends on DM_VIDEO
 	help
 	  Sometimes, for example if the display is mounted in portrait
 	  mode or even if it's mounted landscape but rotated by 180degree,
@@ -164,7 +154,6 @@ config CONSOLE_ROTATION
 
 config CONSOLE_TRUETYPE
 	bool "Support a console that uses TrueType fonts"
-	depends on DM_VIDEO
 	help
 	  TrueTrype fonts can provide outline-drawing capability rather than
 	  needing to provide a bitmap for each font and size that is needed.
@@ -173,7 +162,6 @@ config CONSOLE_TRUETYPE
 
 config DM_PANEL_HX8238D
 	bool "Enable Himax HX-8238D LCD driver"
-	depends on DM_VIDEO
 	help
 	  Support for HX-8238D LCD Panel
 	  The  HX8238-D is a single chip controller and driver LSI that
@@ -213,7 +201,6 @@ config NO_FB_CLEAR
 
 config PANEL
 	bool "Enable panel uclass support"
-	depends on DM_VIDEO
 	default y
 	help
 	  This provides panel uclass driver that enables basic panel support.
@@ -230,7 +217,6 @@ source "drivers/video/fonts/Kconfig"
 
 config VIDCONSOLE_AS_LCD
 	bool "Use 'vidconsole' when CONFIG_VIDCONSOLE_AS_NAME string is seen in stdout"
-	depends on DM_VIDEO
 	help
 	  This is a work-around for boards which have 'lcd' or 'vga' in their
 	  stdout environment variable, but have moved to use driver model for
@@ -423,7 +409,7 @@ config VIDEO_LCD_ANX9804
 
 config ATMEL_LCD
 	bool "Atmel LCD panel support"
-	depends on DM_VIDEO && ARCH_AT91
+	depends on ARCH_AT91
 
 config ATMEL_LCD_BGR555
 	bool "Display in BGR555 mode"
@@ -440,7 +426,6 @@ config VIDEO_BCM2835
 
 config VIDEO_LCD_ORISETECH_OTM8009A
 	bool "OTM8009A DSI LCD panel support"
-	depends on DM_VIDEO
 	select VIDEO_MIPI_DSI
 	help
 	Say Y here if you want to enable support for Orise Technology
@@ -448,7 +433,6 @@ config VIDEO_LCD_ORISETECH_OTM8009A
 
 config VIDEO_LCD_RAYDIUM_RM68200
 	bool "RM68200 DSI LCD panel support"
-	depends on DM_VIDEO
 	select VIDEO_MIPI_DSI
 	help
 	Say Y here if you want to enable support for Raydium RM68200
@@ -484,7 +468,6 @@ config VIDEO_LCD_SSD2828_RESET
 
 config VIDEO_LCD_TDO_TL070WSH30
 	bool "TDO TL070WSH30 DSI LCD panel support"
-	depends on DM_VIDEO
 	select VIDEO_MIPI_DSI
 	help
 	Say Y here if you want to enable support for TDO TL070WSH30
@@ -578,7 +561,6 @@ config NXP_TDA19988
 
 config ATMEL_HLCD
 	bool "Enable ATMEL video support using HLCDC"
-	depends on DM_VIDEO
 	help
 	   HLCDC supports video output to an attached LCD panel.
 
@@ -623,7 +605,7 @@ source "drivers/video/rockchip/Kconfig"
 
 config VIDEO_ARM_MALIDP
 	bool "Enable Arm Mali Display Processor support"
-	depends on DM_VIDEO && OF_CONTROL
+	depends on OF_CONTROL
 	select VEXPRESS_CLK
 	help
 	  This enables support for Arm Ltd Mali Display Processors from
@@ -651,7 +633,6 @@ config VIDEO_TEGRA20
 
 config VIDEO_TEGRA124
 	bool "Enable video support on Tegra124"
-	depends on DM_VIDEO
 	help
 	   Tegra124 supports many video output options including eDP and
 	   HDMI. At present only eDP is supported by U-Boot. This option
@@ -664,7 +645,6 @@ source "drivers/video/imx/Kconfig"
 
 config VIDEO_MXS
 	bool "Enable video support on i.MX28/i.MX6UL/i.MX7 SoCs"
-	depends on DM_VIDEO
 	help
 	  Enable framebuffer driver for i.MX28/i.MX6UL/i.MX7 processors
 
@@ -678,14 +658,14 @@ config VIDEO_NX
 
 config VIDEO_SEPS525
 	bool "Enable video support for Seps525"
-	depends on DM_VIDEO && DM_GPIO
+	depends on DM_GPIO
 	help
 	  Enable support for the Syncoam PM-OLED display driver (RGB 160x128).
 	  Currently driver is supporting only SPI interface.
 
 config VIDEO_ZYNQMP_DPSUB
 	bool "Enable video support for ZynqMP Display Port"
-	depends on DM_VIDEO && ZYNQMP_POWER_DOMAIN
+	depends on ZYNQMP_POWER_DOMAIN
 	help
 	  Enable support for Xilinx ZynqMP Display Port. Currently this file
 	  is used as placeholder for driver. The main reason is to record
@@ -695,7 +675,6 @@ source "drivers/video/nexell/Kconfig"
 
 config CONSOLE_SCROLL_LINES
 	int "Number of lines to scroll the console by"
-	depends on DM_VIDEO
 	default 1
 	help
 	  When the console need to be scrolled, this is the number of
@@ -753,7 +732,6 @@ config VIDEO_DT_SIMPLEFB
 
 config VIDEO_MCDE_SIMPLE
 	bool "Simple driver for ST-Ericsson MCDE with preconfigured display"
-	depends on DM_VIDEO
 	help
 	  Enables a simple display driver for ST-Ericsson MCDE
 	  (Multichannel Display Engine), which reads the configuration from
@@ -885,27 +863,25 @@ config VIDEO_LOGO_MAX_SIZE
 
 config VIDEO_BMP_RLE8
 	bool "Run length encoded BMP image (RLE8) support"
-	depends on DM_VIDEO
 	help
 	  If this option is set, the 8-bit RLE compressed BMP images
 	  is supported.
 
 config BMP_16BPP
 	bool "16-bit-per-pixel BMP image support"
-	depends on DM_VIDEO
 	help
 	  Support display of bitmaps file with 16-bit-per-pixel
 
 config BMP_24BPP
 	bool "24-bit-per-pixel BMP image support"
-	depends on DM_VIDEO
 	help
 	  Support display of bitmaps file with 24-bit-per-pixel.
 
 config BMP_32BPP
 	bool "32-bit-per-pixel BMP image support"
-	depends on DM_VIDEO
 	help
 	  Support display of bitmaps file with 32-bit-per-pixel.
 
+endif # DM_VIDEO
+
 endmenu